<?php 


class PlinkPaymentgatewayPaymentModuleFrontController extends ModuleFrontController
{
  public $ssl = true;
  private const MODULE_NAME="plinkpaymentgateway";
  private const PLINK_ORDER_TABLE="plink_pg";
  

  public function initContent()
  {
    parent::initContent();
    $link = new Link();
    $logo_path = Media::getMediaPath(_PS_MODULE_DIR_.self::MODULE_NAME.'/assets/img/plink-logo.png');

    try{
      
      $cart = $this->context->cart;
      // $isOrderX = Db::getInstance()->getRow(' SELECT * FROM '._DB_PREFIX_.'orders WHERE id_customer = '.$cart->id_customer.' ORDER BY id_order DESC');
      
      // if(!isset($isOrderX['id_order'])){
      //   throw new Exception("no order has been made lately");    
      // }

      //if order id received
      // if(Tools::getValue('order_id') === null){
      //   throw new Exception("No order id received");    
      // }

      //get id order from params
      // $order_id=Tools::getValue('order_id');
      
      // $order_id = $isOrderX['id_order'];

      //check if exist
      // $this->context->cookie->__isset('your_cookie_name');
      
      $order_id = $this->context->cookie->__get('order_id');

      $helper = new PlinkPaymentGatewayHelper($this);

      if(!isset($order_id) || $order_id === false || $order_id === ""){
        Tools::redirect(_PS_BASE_URL_.__PS_BASE_URI__);    
      }

      $order = new Order($order_id); 

      $helper->isExistOrder($order);

      //if status exists
      $sql = "SELECT plink_payment_status FROM "._DB_PREFIX_ .self::PLINK_ORDER_TABLE." WHERE order_id = ".$order->id;
      $row = Db::getInstance()->getRow($sql);

      if(!$row) throw new Exception("Something went wrong ..Can't insert to Plink Table");
      
      //is order id already exist plink table
      if($row['plink_payment_status']){
        
        //unset cookie
        $this->context->cookie->__unset('order_id');
        
        $type = array(
            'SETLD'=>'success',
            'PENDG'=>'pending',
            'REJEC'=>'failed'
        );

        $message= array(
            'SETLD'=>'Payment successful',
            'PENDG'=>'Payment is pending',
            'REJEC'=>'Payment Reject'
        );
        
        $arr_btn = null;

        if($row['plink_payment_status'] === 'PENDG'){
        
          $arr_btn = array(
            array(
                'txt_btn' => 'Retry',
                'url' => $_SERVER['REQUEST_URI'],
                'icon'=> 'undo'
            ),
            array(
                'txt_btn' => 'Continue Shopping',
                'url' =>  _PS_BASE_URL_.__PS_BASE_URI__,
                'icon'=> 'store'
            )
          );
          
        }else{

          $arr_btn = array(
                array(
                    'txt_btn' => 'Continue Shopping',
                    'url' =>  _PS_BASE_URL_.__PS_BASE_URI__,
                    'icon'=> 'store'
                )
            );

        }
        
        $data = array(
          'msg'=>$message[$row['plink_payment_status']],
          'btns'=> $arr_btn
        );

        $this->context->smarty->assign(array(
                      'buttons' =>$data['btns'],
                      'img_logo' => $logo_path,
                      'msg'=> $data['msg']
                  ));
        return $this->setTemplate('module:'.self::MODULE_NAME.'/views/templates/module/plink_dialogpage.tpl');

      }

      $data = $this->composeData($order);

      $res = $helper->request($data);
      $response =  json_decode($res,true);
      if($response['response_code'] ===  'MBDD00'){

        $helper->changePsOrderStatus('awaiting',$order_id);

        $this->context->smarty->assign(array(
            'plink_paymentpage_msg' => "Please make a payment soon by using Virtual Account numbers in the PLINK window below. To check your payment status you can click the button check payment status",
            'home_url' => _PS_BASE_URL_.__PS_BASE_URI__,
            'txt_btn_home' => "Continue Shopping",
            'iframe_url' =>$data['base_url'].$response['payment_page_url'],
            'btn_text_check' => 'Check paymment status'     
        ));
        
        $this->setTemplate('module:'.self::MODULE_NAME.'/views/templates/module/plink_paymentpage.tpl');

      }else{
        throw new \Exception("Something went wrong: ".$response['response_description']);
      }
      	
    }catch(\Exception $e){
      $data = array(
            'msg'=>$e->getMessage(),
            'btns'=> array(
              array(
                  'txt_btn' => 'Retry',
                  'url' => $_SERVER['REQUEST_URI'],
                  'icon'=> 'undo'
              ),
              array(
                  'txt_btn' => 'Continue Shopping',
                  'url' =>  _PS_BASE_URL_.__PS_BASE_URI__,
                  'icon'=> 'store'
              )
            )
      );
      $this->context->smarty->assign(array(
                'buttons' =>$data['btns'],
                'img_logo' => $logo_path,
                'msg'=> $data['msg']
            ));
      return $this->setTemplate('module:'.self::MODULE_NAME.'/views/templates/module/plink_dialogpage.tpl');
    }
  }


  public function composeData($order){

    $actionurl = array(
        "test"     => 'http://dev.plink.co.id:8280',
        "live"  => 'https://secure2.plink.co.id',
    );

    $frontend_callback_url = array(
        "test" => "https://www.commerce.plink.co.id",
        "live"  => Context::getContext()->shop->getBaseURL(true),
    );

    $backend_callback_url = array(
        "test"     => "https://www.commerce.plink.co.id/plinkpg-paymentflag/",
        "live"  => $this->context->link->getModuleLink(self::MODULE_NAME,'payment_flag'),
    );


    $product_details = array();

    //remapping items data
    foreach($order->getProducts() as $product){
        $product_details[] = array(
            "item_code" => $product['id_product'], 
            "item_title" => $product['product_name'], 
            "quantity" => intval(ceil($product['product_quantity'])), 
            "total" => intval(ceil($product['total_wt'])), 
            "currency" => "IDR" 
        );
    }

    $other_bills = array(
        array( "title" => 'Carrier Tax',"value" => intval(ceil($order->carrier_tax_rate))),
        array( "title" => 'Shipping',"value" => intval(ceil($order->total_shipping))),
        array( "title" => 'Wrapping',"value" => intval(ceil($order->total_wrapping)))
    );
    
    $invoice_address = new Address($order->id_address_invoice);

    $shipping_address = [
        "address" => AddressFormat::generateAddress($invoice_address, array(), ',', ' '), 
        "telephoneNumber" => $invoice_address->phone, 
        "handphoneNumber" => $invoice_address->phone_mobile,
    ];

    $msg = Message::getMessageByCartId($order->id_cart);
    $comment = $msg ? $msg['message'] : '';
    $env = Configuration::get('CONF_PLINKPAYMENTGATEWAY_MODE');
    $customer = new Customer($order->id_customer);
    
    $body=[
        "invoice_number"=> $order->invoice_number,
        "merchant_id" => Configuration::get('CONF_PLINKPAYMENTGATEWAY_MERCHANTCODE'),
        "merchant_key_id" => Configuration::get('CONF_PLINKPAYMENTGATEWAY_MERCHANTKEYID'),
        "merchant_ref_no" => (string)$order->id, 
        "transaction_currency" => "IDR", 
        "transaction_amount" => intval(ceil($order->total_paid)), 
        "product_details" => json_encode($product_details), 
        "user_name" =>  $customer->firstname.' '.$customer->lastname,
        "user_email" =>   $customer->email,
        "user_phone_number" => $invoice_address->phone ?? $invoice_address->phone_mobile,
        "user_id" => $order->id_customer,
        "backend_callback_url" => $backend_callback_url[Configuration::get('CONF_PLINKPAYMENTGATEWAY_MODE')], 
        "frontend_callback_url" => $frontend_callback_url[Configuration::get('CONF_PLINKPAYMENTGATEWAY_MODE')],
        "transaction_date_time" => date('Y-m-d H:i:s P'), 
        "transmission_date_time" => date('Y-m-d H:i:s P'), 
        "remarks" => $comment,
        "user_device_id" => $_SERVER['HTTP_USER_AGENT'], 
        "user_ip_address" => $_SERVER['REMOTE_ADDR'] ?? '127.0.0.1', 
        "shipping_details" => json_encode($shipping_address), 
        "payment_method" => "", 
        "other_bills" => json_encode($other_bills)
      ];
     
      $body_string=json_encode($body,JSON_UNESCAPED_SLASHES|JSON_PRETTY_PRINT);
      
      //create hmac token
      $secret_key = Configuration::get('CONF_PLINKPAYMENTGATEWAY_SECRETKEY');
      $payload = json_encode($body,JSON_UNESCAPED_SLASHES|JSON_PRETTY_PRINT);
      $token = hash_hmac('sha256', $payload, $secret_key);

      $header=array(
          'Content-Type: application/json',
          'Accept: application/json',
          'mac:'.$token  
      );

      $data=array(
          'order_id'=>$order->id,
          'base_url' => $actionurl[$env],
          'end_point' => '/integration/transaction/api/submit-trx',
          'body' => $body_string,
          'header' => $header,
          'method' => 'POST'
      );
    return  $data;
  }

  // public function updateOrderHistory(array $data){
  //   $sql="INSERT INTO ".self::PLINK_ORDER_TABLE." 
  //      VALUES({$data['order_id']},
  //      '',
  //      '{$data['user_id']}',
  //      '',
  //      '{$data['email']}',
  //      '{$data['order_created']}',
  //      '',
  //      '')
  //   ";
  //   $query=Db::getInstance()->execute($sql);
  //   if(!$query){
  //     throw new Exception("Failed to save order data");
  //   }
  // }

  // public static function request($data){
  //   $url=$data['base_url'].$data['end_point'];
  //   $body = $data['body'];
  //   $headers = $data['header'];
  //   $ch = curl_init();		
  //   curl_setopt($ch, CURLOPT_URL,$url);
  //   curl_setopt($ch, CURLOPT_POST, TRUE);
  //   curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $data['method']);  
  //   curl_setopt($ch, CURLOPT_POSTFIELDS, $body);
        
  //   curl_setopt($ch, CURLOPT_HEADER, true);
  //       curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
  //   curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
  //   curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  //   curl_setopt($ch, CURLOPT_BINARYTRANSFER, true);
  //   curl_setopt($ch, CURLOPT_CONNECTTIMEOUT ,0); 
  //   curl_setopt($ch, CURLOPT_TIMEOUT, 60); //timeout in seconds
  //   if( substr( $url, 0, 5 ) == "https" ){
  //     curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
  //     curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
  //   }
  //       curl_setopt($ch, CURLOPT_VERBOSE, true);
  //   $retValue = curl_exec($ch);


        
  //   $headsize = curl_getinfo($ch, CURLINFO_HEADER_SIZE);
  //   $headers_ = substr($retValue, 0, $headsize);
  //   $response = trim(substr($retValue, $headsize));

  //       if (curl_errno($ch)) {
  //           throw new \Exception(curl_error($ch));
  //       }
  //       curl_close($ch);
        
  //   return $response;
  // }

  // public function isExistOrder($order){

  //   $customer = new Customer($order->id_customer);
  //   $msg=Message::getMessageByCartId($order->id_cart);
    
  //   $sql = "SELECT order_id FROM "._DB_PREFIX_ .self::PLINK_ORDER_TABLE." WHERE order_id = ".$order->id;
    
  //   $result = Db::getInstance()->getRow($sql);
    
  //   //if exist
  //   if(!$result){ 
  //     $sql = "INSERT INTO "._DB_PREFIX_ .self::PLINK_ORDER_TABLE;
  //     $sql .= " VALUES( {$order->id},'','{$order->id_customer}','','{$customer->email}','".date('Y-m-d H:i:s')."','','{$msg['message']}')";
  //     Db::getInstance()->query($sql);
  //   }

  // }

  // public function generateResponse(int $code,array $res){
  
  //   $response_data = array();
  //   $response_data['code'] = $code;
    
  //   foreach($res as $key => $value){
  //     $response_data[$key] = $value;
  //   }

  //   header('Content-Type: application/json');
  //   echo json_encode($response_data);
  //   exit;
  // }

  // public function generateDialog(array $err,$this){
    
  //   $this->context->smarty->assign(array(
  //       'buttons' =>$err['btns'],
  //       'img_logo' => Media::getMediaPath(_PS_MODULE_DIR_.self::MODULE_NAME.'/assets/img/plink-logo.png'),
  //       'msg'=> $err['msg']
  //   ));

  //   return $this->setTemplate('module:'.self::MODULE_NAME.'/views/templates/module/plink_dialogpage.tpl');
 
  // }

}

?>
