<?php 


class PlinkPaymentgatewayPayment_FlagModuleFrontController extends ModuleFrontController
{
  private $module_name="plinkpaymentgateway";
  private const PLINK_ORDER_TABLE="plink_pg";

  public function initContent()
  {
    parent::initContent();
    $this->ajax=true;
  }

  public function displayAjax(){
    
  }

  public function postProcess(){

      $incomingdata=file_get_contents('php://input'); //body request 

      $helper = new PlinkPaymentGatewayHelper($this);
      $isConfigurationSet = $helper->isAllConfigurationHasSet();

      if($_SERVER['REQUEST_METHOD'] !== 'POST'){
          Tools::redirect("?controller=404");
      }
      else if(!isset($incomingdata) || empty($incomingdata)){
          $helper->generateResponse(400, array("error"=>"No payload received or payload is empty"));
      }
      else if(!$isConfigurationSet->status){
        $error_config_messages='';
        
        $i=0;

        foreach($isConfigurationSet->errors as $value){
            if($i < (count($isConfigurationSet->errors)-1)){
                $error_config_messages .= $value.',';
            }else{
                $error_config_messages .= $value;
            }

            $i++;   
        }
        $helper->generateResponse(400, array("error"=>"Configuration Error: ".$error_config_messages));
      }
      else{
          try{
            $secret_key = Configuration::get('CONF_PLINKPAYMENTGATEWAY_SECRETKEY');
            $hash = hash_hmac('sha256', json_encode($incomingdata), $secret_key);

            if($_SERVER['HTTP_MAC'] != $hash){
                return $helper->generateResponse(400, array("error" => "Request is not allowed. Access denied!"));
            }

            $this->validateOverallPayload($incomingdata);
            $incomingArray = json_decode($incomingdata,true);
            $helper->isExistPlinkOrder($incomingArray);       
            $helper->updatePlinkOrderHistory($incomingArray);
            
            $backend_status=[
                "SETLD"=>"PLINK  Payment Success",
                "REJCT"=>"PLINK  Payment Failed",
                "PENDG"=>"PLINK  Payment Pending"
            ];
            
            $msg_res=array(
              "order_id" => $incomingArray['merchant_ref_no'],
              "msg" => $backend_status[$incomingArray['payment_status']]
            );

            $ps_order_status=[
                "SETLD"=>"success",
                "REJCT"=>"reject",
                "PENDG"=>"pending"
            ];

            $helper->changePsOrderStatus($ps_order_status[$incomingArray['payment_status']],$incomingArray['merchant_ref_no']);

            $helper->generateResponse(200, $msg_res);
          
          }catch(\Exception $e){
              $helper->generateResponse(400, array("error" => $e->getMessage()));
          }
      }
  }

  public function validateOverallPayload($payloads){
    $payload_requires =['payment_status','plink_ref_no','merchant_ref_no','payment_method','user_id','user_email','payment_date','validity'];
    $accepted_payment_status=['SETLD','PENDG','REJEC'];    
    $arr_payload = json_decode($payloads,true);

    foreach($payload_requires as $value){
        if(!isset($arr_payload[$value])){
          throw new Exception("Payload ".$value." doesn't exist");
        }

        if(preg_match("/[\t\r\n]|(\'|--[^\r\n]*)|(\/\*[\w\W]*?(?=\*)\*\/)  /",$arr_payload[$value])){
          throw new Exception("Parameter ".$value." contains invalid character");
        }
    }

    //specific payload validation
    if(!in_array($arr_payload['payment_status'],$accepted_payment_status)){
      throw new Exception("Invalid payment status");
    }

  }


  // public function isExistOrder($data){
  //   $sql = "SELECT order_id FROM "._DB_PREFIX_ .self::PLINK_ORDER_TABLE." WHERE order_id = '".$data['merchant_ref_no']."'";
  //   $result = Db::getInstance()->getRow($sql);
  //   if(!$result){ throw new Exception("Order id doesn't exist"); } 
  // }

  // public function updateOrderHistory($data){
  //   $sql="UPDATE "._DB_PREFIX_.self::PLINK_ORDER_TABLE." 
  //       SET plink_payment_status='".$data['payment_status']."',
  //           plink_ref_no='".$data['plink_ref_no']."',
  //           payment_date='".$data['payment_date']."'
  //       WHERE 
  //           order_id='".$data['merchant_ref_no']."';
  //   ";
  //   $query=Db::getInstance()->execute($sql);

  //   if(!$query){
  //     throw new Exception("Failed to save data");
  //   }
    
  // }

  // public function generateResponse(int $code,array $res){
  //   $response_data = array();
  //   $response_data['code'] = $code;
    
  //   foreach($res as $key => $value){
  //     $response_data[$key] = $value;
  //   }

  //   header('Content-Type: application/json');
  //   echo json_encode($response_data);
  // }

}

?>