<?php 

    class PlinkPaymentGatewayHelper{
        
        private $that;
        private const PLINK_ORDER_TABLE=_DB_PREFIX_."plink_pg";

        public function __construct($context){
            $this->that = $context;
        }
        
        public function isCookieEnabled(){
            setcookie('plinktestcookie', "PLINK COOKIE");
            if (isset($_COOKIE['plinktestcookie'])){
                return true;
            }
            return false;
        }

        public function updatePlinkOrderHistory(array $data){
            $sql="  UPDATE ".self::PLINK_ORDER_TABLE." 
                    SET plink_payment_status='".$data['payment_status']."',
                    plink_ref_no='".$data['plink_ref_no']."',
                    payment_date='".$data['payment_date']."'
                    WHERE 
                    order_id=".$data['merchant_ref_no'].";
            ";
            $query=Db::getInstance()->execute($sql);

            if(!$query){
                 throw new Exception("Failed to save order data");
            }
        }

        public function isAllConfigurationHasSet(){
           $configs = array(
            'Merchant Code' =>'CONF_PLINKPAYMENTGATEWAY_MERCHANTCODE',
            'Secret Key' => 'CONF_PLINKPAYMENTGATEWAY_SECRETKEY',
            'Merchant Key ID' => 'CONF_PLINKPAYMENTGATEWAY_MERCHANTKEYID',
            'Mode' => 'CONF_PLINKPAYMENTGATEWAY_MODE',
            'Map Payment Status Success' => 'CONF_PLINKPAYMENTGATEWAY_PLINKPGSUCCESS',
            'Map Payment Status Pending' => 'CONF_PLINKPAYMENTGATEWAY_PLINKPGPENDING',
            'Map Payment Status Awaiting' => 'CONF_PLINKPAYMENTGATEWAY_PLINKPGWAITING',
            'Map Payment Status Reject' => 'CONF_PLINKPAYMENTGATEWAY_PLINKPGREJECT'
           );
           
           $errors = array(); 
           
            foreach($configs as $key => $value){
                if(!Configuration::get($value)){
                    array_push($errors,"Error Doens't have configuration value for - ".$key); 
                }
            }

            $result =   array(
                'status' => count($errors) > 0 ? false : true,
                'errors' => $errors
            );

            return json_decode(json_encode($result),false);
        }
        
        public function changePsOrderStatus($status,$order_id){
            
            $status_list = array(
                'rejected' =>Configuration::get('CONF_PLINKPAYMENTGATEWAY_PLINKPGREJECT'),
                'pending' =>Configuration::get('CONF_PLINKPAYMENTGATEWAY_PLINKPGPENDING'),
                'awaiting' =>Configuration::get('CONF_PLINKPAYMENTGATEWAY_PLINKPGWAITING'),
                'success' =>Configuration::get('CONF_PLINKPAYMENTGATEWAY_PLINKPGSUCCESS'),
            );
            $history = new OrderHistory();
            $history->id_order = (int)$order_id;
            $history->changeIdOrderState($status_list[$status], (int)($order_id));
        }

        public function request($data){
            $url=$data['base_url'].$data['end_point'];
	    $body = $data['body'];
            $headers = $data['header'];

            $ch = curl_init();		
            curl_setopt($ch, CURLOPT_URL,$url);
            curl_setopt($ch, CURLOPT_POST, TRUE);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $data['method']);  
            curl_setopt($ch, CURLOPT_POSTFIELDS, $body);
                
            curl_setopt($ch, CURLOPT_HEADER, true);
                curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_BINARYTRANSFER, true);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT ,0); 
            curl_setopt($ch, CURLOPT_TIMEOUT, 60); //timeout in seconds
            if( substr( $url, 0, 5 ) == "https" ){
                curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
            }
                curl_setopt($ch, CURLOPT_VERBOSE, true);
            $retValue = curl_exec($ch);

            $headsize = curl_getinfo($ch, CURLINFO_HEADER_SIZE);
            $headers_ = substr($retValue, 0, $headsize);
            $response = trim(substr($retValue, $headsize));

                if (curl_errno($ch)) {
                    throw new \Exception(curl_error($ch));
                }
                curl_close($ch);
                
            return $response;   
        }

        public function isExistOrder($order){

            $customer = new Customer($order->id_customer);
            $msg = Message::getMessageByCartId($order->id_cart);

            $sql = "SELECT order_id FROM ".self::PLINK_ORDER_TABLE." WHERE order_id = ".$order->id;

            $result = Db::getInstance()->getRow($sql);
            $comment = $msg ? $msg['message'] : '';
            
            //if exist
            if(!$result){ 
                $sql = "INSERT INTO ".self::PLINK_ORDER_TABLE;
                $sql .= " VALUES( {$order->id},'','{$order->id_customer}','','{$customer->email}','".date('Y-m-d H:i:s')."','','{$comment }')";
                Db::getInstance()->query($sql);
            }

        }

        public function isExistPlinkOrder($data){
            $sql = "SELECT order_id FROM ".self::PLINK_ORDER_TABLE." WHERE order_id = ".$data['merchant_ref_no'];
            $result = Db::getInstance()->getRow($sql);
            if(!$result){ throw new Exception("Order id doesn't exist"); } 
        }

        public function generateResponse(int $code,array $res){

            $response_data = array();
            $response_data['code'] = $code;

            foreach($res as $key => $value){
                $response_data[$key] = $value;
            }

            header('Content-Type: application/json');
            echo json_encode($response_data);
            exit;
        }

    }

?>
